/*
**
**
** VERY simple yao sample
** nonsense.C
** Pekka Kataja 1995
**
**
*/


#include <iostream.h>

#include <gendef.h>
#include <parser.h>
#include <server.h>
#include <errorh.h>
#include <pubid.h>

static char const TERMINAL [] = "TERMINAL" ;

unsigned int main ( int argc , const char **argv )
{

	if ( argc < 2 ) {
	  cerr << "try:" << argv [0] << " -h" << endl ;
	  exit ( 1 ) ;
	}


  SGMLparser *pSgml = (SGMLparser *) 0 ;  // SGML parser
  ResolvePublicId pubid ;                 // public id resolver
  
  char *ocsFileSpec = (char *) 0 ;
  char *primaryFileSpec = TERMINAL ;
  int isProduction = 0 ;
  int sortRequired = 1 ;
  
  int opt ;
  extern int optind;
  extern char *optarg;
  extern int opterr;
  extern int optopt;

  while ( ( opt = getopt ( argv , argv , "s:m:h?" ) ) > 0 ) {
    switch ( opt ) {
    case 'm' :
      pubid.addcatalog ( optarg ) ;
      break ;
    case 's' :
      ocsFileSpec = optarg ;
      break ;
    case 'h' :
    case '?' :
      cerr << "usage:" << argv [0] << " [-m mapcatalogfile] [-s syntaxfile] primaryFileSpec" << endl ;
      exit ( 0 ) ;
    }
  }

  if ( argv [optind] ) 
    primaryFileSpec = argv [optind] ;  
	
  Document doc ( primaryFileSpec , ocsFileSpec , TERMINAL , 
	 isProduction , sortRequired ) ;

  pSgml = new SGMLparser ( doc ) ;
  if ( ! pSgml )
    cerr << "Something went wrong, Sorry" << endl ;


  for ( ;; ) {

    e_Event evType = pSgml->event() ;     // get current event
    switch ( evType ) {

      // --- Primary events ---
    case EOP_EV            :  return 0 ;
    case SGML_START_EV     : cout << "SGML_START_EV:"     ; break ;
    case SGML_END_EV       : cout << "SGML_END_EV:"       ; break ;
    case DOCTYPE_START_EV  : cout << "DOCTYPE_START_EV:"  ; break ;
    case DOCTYPE_END_EV    : cout << "DOCTYPE_END_EV:"    ; break ;
    case LINKTYPE_START_EV : cout << "LINKTYPE_START_EV:" ; break ;
    case LINKTYPE_END_EV   : cout << "LINKTYPE_END_EV:"   ; break ;
    case SECTION_START_EV  : cout << "SECTION_START_EV:"  ; break ;
    case SECTION_END_EV    : cout << "SECTION_END_EV:"    ; break ;
    case ELEMENT_START_EV  : cout << endl << "ELEMENT_START_EV:"  ; break ;
    case ELEMENT_END_EV    : cout << "ELEMENT_END_EV:"    ; break ;
    case DATA_EV           : cout << "DATA_EV:"           ; break ;
    case RE_EV             : cout << "RE_EV:"             ; break ;
    case ENTITY_START_EV   : cout << "ENTITY_START_EV:"   ; break ;
    case ENTITY_END_EV     : cout << "ENTITY_END_EV:"     ; break ;
    case PI_EV             : cout << "PI_EV:"             ; break ;
    case COMMENT_EV	       : cout << "COMMENT_EV:"        ; break ;
    case ERROR_EV          : cout << "ERROR_EV:"          ; break ;

      // --- Decomposed events ---
    case ATT_NAME_EV        : cout << "ATT_NAME_EV:"         ; break ;  
    case DATA_ATT_NAME_EV   : cout << "DATA_ATT_NAME_EV:"    ; break ;
    case ATT_VAL_IMPLIED_EV : cout << "ATT_VAL_IMPLIED_EV:"  ; break ;
    case ATT_VAL_INVALID_EV : cout << "ATT_VAL_INVALID_EV:"  ; break ;
    case ATT_VAL_ENTITY_EV  : cout << "ATT_VAL_ENTITY_EV:"   ; break ;
    case ATT_VAL_ID_EV      : cout << "ATT_VAL_ID_EV:"       ; break ;
    case ATT_VAL_IDREF_EV   : cout << "ATT_VAL_IDREF_EV:"    ; break ;
    case ATT_VAL_NAME_EV    : cout << "ATT_VAL_NAME_EV:"     ; break ;
    case ATT_VAL_NMTOKEN_EV : cout << "ATT_VAL_NMTOKEN_EV:"  ; break ; 
    case ATT_VAL_NUMBER_EV  : cout << "ATT_VAL_NUMBER_EV:"   ; break ;
    case ATT_VAL_NUTOKEN_EV : cout << "ATT_VAL_NUTOKEN_EV:"  ; break ;
    case ATT_VAL_CDATA_EV   : cout << "ATT_VAL_CDATA_EV:"    ; break ;
    case ATT_VAL_COMPOSITE_EV  : cout << "ATT_VAL_COMPOSITE_EV:"  ; break ;
    case ATT_VAL_COMPOSITE_SDATA_EV :  cout << "ATT_VAL_COMPOSITE_SDATA_EV:" ; break ;
    case ATT_VAL_COMP_DATA_EV  : cout << "ATT_VAL_COMP_DATA_EV:"  ; break ;
    case ATT_VAL_COMP_CDATA_EV : cout << "ATT_VAL_COMP_CDATA_EV:" ; break ;
    case ATT_VAL_COMP_SDATA_EV : cout << "ATT_VAL_COMP_SDATA_EV:" ; break ;
    case ATT_VAL_TOKENS_EV     : cout << "ATT_VAL_TOKENS_EV:"     ; break ;
    case ATT_VAL_TOKEN_ENTITY_EV : cout << "ATT_VAL_TOKEN_ENTITY_EV:" ; break ;
    case ATT_VAL_TOKEN_ID_EV     : cout << "ATT_VAL_TOKEN_ID_EV:"     ; break ;
    case ATT_VAL_TOKEN_IDREF_EV  : cout << "ATT_VAL_TOKEN_IDREF_EV:"  ; break ;
    case ATT_VAL_TOKEN_NAME_EV   : cout << "ATT_VAL_TOKEN_NAME_EV:"   ; break ;
    case ATT_VAL_TOKEN_NMTOKEN_EV : cout << "ATT_VAL_TOKEN_NMTOKEN_EV:" ; break ;
    case ATT_VAL_TOKEN_NUMBER_EV  : cout << "ATT_VAL_TOKEN_NUMBER_EV:"  ; break ;
    case ATT_VAL_TOKEN_NUTOKEN_EV : cout << "ATT_VAL_TOKEN_NUTOKEN_EV:" ; break ;
    case ATT_VAL_NOTATION_EV      : cout << "ATT_VAL_NOTATION_EV:"      ; break ;
    case ATT_VAL_NMTOK_IN_GROUP_EV : cout << "ATT_VAL_NMTOK_IN_GROUP_EV:"  ; break ;

    case ENT_INT_SGML_EV  : cout << "ENT_INT_SGML_EV:"            ; break ;
    case ENT_INT_CDATA_EV : cout << "ENT_INT_CDATA_EV:"      ; break ;
    case ENT_INT_SDATA_EV : cout << "ENT_INT_SDATA_EV:"      ; break ;
    case ENT_INT_PI_EV    : cout << "ENT_INT_PI_EV:"         ; break ;
    case ENT_INT_STARTTAG_EV  :  cout << "ENT_INT_STARTTAG_EV:"   ; break ;
    case ENT_INT_ENDTAG_EV : cout << "ENT_INT_ENDTAG_EV:"     ; break ;
    case ENT_INT_MS_EV     : cout << "ENT_INT_MS_EV:"         ; break ;
    case ENT_INT_MD_EV     : cout << "ENT_INT_MD_EV:"         ; break ;
    case ENT_EXT_SGML_EV   : cout << "ENT_EXT_SGML_EV:"       ; break ;
    case ENT_EXT_SUBDOC_EV : cout << "ENT_EXT_SUBDOC_EV:"     ; break ;
    case ENT_EXT_CDATA_EV  : cout << "ENT_EXT_CDATA_EV:"      ; break ;
    case ENT_EXT_NDATA_EV  : cout << "ENT_EXT_NDATA_EV:"      ; break ;
    case ENT_EXT_SDATA_EV  : cout << "ENT_EXT_SDATA_EV:"      ; break ;

    case PUBLIC_ID_EV : cout << "PUBLIC_ID_EV:" ; break ;
    case SYSTEM_ID_EV : cout << "SYSTEM_ID_EV:" ; break ;
    case SYSTEM_ID_OMITTED_EV : cout << "SYSTEM_ID_OMITTED_EV:"  ; break ;
    case ENT_NOTATION_EV : cout << "ENT_NOTATION_EV:" ; break ;
  
    default: cout << "UNKNOWN EVENT:" ; break ;
    }

    cout << "\t->" << pSgml->zstring () << "<-" << endl ;
  }

}

