/*-------------------------------------------------------------------------
                PROJECT YAO OBJECT SGML PARSER (OSGML)
                     Version 1.0 Alpha level 4.0
   An SGML Parser conforming to International Standard ISO 8879 --
                 Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

               INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------
//// attldcl.h
///  Declarations for attldcl
//   Pierre G. Richard 94/02/02 - Petrus Services and Consulting, Ltd.
  -------------------------------------------------------------------------*/
#ifndef _ATTLDCL_H
#define _ATTLDCL_H 1

#include "attrib.h"     // part of a class

/*-----------------------------------------------------------------------------+
| Attlist declaration                                                          |
+-----------------------------------------------------------------------------*/
class AttlistDcl :
   private virtual PrologDcl           // IS_A?
{
public:
   void parse(const e_LinkKind lkkind);
   void new_attlist_gi();
   void new_declared_value();

private:
   e_LinkKind lkkindPV;
   char *pszNamePV;
   void **ppPatch;
   AttributeList *pAttlistPV;
   unsigned int iCountAttcntPV;
   boolean isNotationAdl;
};

/*-----------------------------------------------------------------------------+
| AttributeNode - these structures are used while parsing the DTD              |
+-----------------------------------------------------------------------------*/
struct AttributeNodeFlags {     // is: Attribute node Flags
   boolean required :1;         // if TRUE, a REQUIRED attribute exists
   boolean current  :1;         // if TRUE, a CURRENT  attribute exists
   boolean conref   :1;         // if TRUE, a CONREF   attribute exists
   boolean notation :1;         // if TRUE, a NOTATION attribute exists
   boolean entity   :1;         // if TRUE, one or more ENTITY(IES) attributes
   boolean id       :1;         // if TRUE, an ID attribute exists
   boolean solved   :1;         // if TRUE: attribute had explicit specification
};

struct AttributeNode {          // ANODE: Attribute node
   AttributeNode(AttributeNodeFlags isArg, AttributeList& attlistArg);
   int pile_up(
      AttributeRep *&pAttrep, const AttributeRep * const aAttrepTable,
      Component *&pCompo, const Component * const aCompoTable,
      boolean isCatenated = FALSE
   );
   AttributeList attlist;       // Definition list
   unsigned int ixAttrep;       // used when unloading ...
   int iReferenceCount;         // count how many ELEM/NOT reference this node
   AttributeNodeFlags is;
};
#endif /* _ATTLDCL_H **********************************************************/

