/*-------------------------------------------------------------------------
                PROJECT YAO OBJECT SGML PARSER (OSGML)
                     Version 1.0 Alpha level 4.0
   An SGML Parser conforming to International Standard ISO 8879 --
                 Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

               INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------
//// attrib.eh
///  Enumerations for attributes
//   Pierre G. Richard 93/10/15 - Petrus Services and Consulting, Ltd.
  -------------------------------------------------------------------------*/
#ifndef _ATTRIB_EH
#define _ATTRIB_EH 1

enum e_DeclaredValue  {        // AFK  odd number means "plurality"
   INVALID_ADV   =   0,        // None = Invalid (for unsolved NADs)
   CDATA_ADV     =   2,        // character data
   ENTITY_ADV    =   4,        // general entity name
   ENTITIES_ADV  =   5,        // general entity name list
   ID_ADV        =   6,        // an ID
   IDREF_ADV     =   8,        // an ID reference
   IDREFS_ADV    =   9,        // an ID reference list
   NAME_ADV      =  10,        // a name
   NAMES_ADV     =  11,        // a name list
   NMTOKEN_ADV   =  12,        // a name token
   NMTOKENS_ADV  =  13,        // a name token list
   NOTATION_ADV  =  14,        // notation or solved NAD
   NUMBER_ADV    =  16,        // a number
   NUMBERS_ADV   =  17,        // a number list
   NUTOKEN_ADV   =  18,        // a number token
   NUTOKENS_ADV  =  19,        // a number token list
   GROUP_ADV     =  20         // one of a fixed group
};

enum e_DefaultValue {          // AFV: Default Value field
   INVALID_AFV = 0,            // None = Invalid
   IMPLIED_AFV,                // Impliable attribute
   REQUIRED_AFV,               // This attribute is REQUIRED  <= 1 => ID
   CURRENT_AFV,                // Default attribute is CURRENT value
   CONREF_AFV,                 // Content Reference Attribute
   DEFLT_AFV,                  // >= A default value has been specified
   FIXED_AFV                   // This default value is fixed
};

#endif /* _ATTRIB_EH **********************************************************/
