/*-------------------------------------------------------------------------
                PROJECT YAO OBJECT SGML PARSER (OSGML)
                     Version 1.0 Alpha level 4.0
   An SGML Parser conforming to International Standard ISO 8879 --
                 Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

               INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------
//// capacity.eh
///  Enumerations of capacity
//   Pierre G. Richard 93/10/15 - Petrus Services and Consulting, Ltd.
  -------------------------------------------------------------------------*/
#ifndef _CAPACITY_EH
#define _CAPACITY_EH 1

/*-------------------------------+
| Indices to the Capacity Tables |
+-------------------------------*/
enum e_IxCapacity {
   ATTCAP_ix,
   ATTCHCAP_ix,
   AVGRPCAP_ix,
   DTACAP_ix,
   DTACHCAP_ix,
   ELEMCAP_ix,
   ENTCAP_ix,
   ENTCHCAP_ix,
   EXGRPCAP_ix,
   EXNMCAP_ix,
   GRPCAP_ix,
   IDCAP_ix,
   IDREFCAP_ix,
   LKNMCAP_ix,
   LKSETCAP_ix,
   MAPCAP_ix,
   NOTCAP_ix,
   NOTCHCAP_ix,
   TOTALCAP_ix,
   NOT_FOUND_CAP_ix, CAP_MAX_SIZE = NOT_FOUND_CAP_ix  // must be last entries
};

/*
| Values from the Reference Concrete Syntax
*/
extern const long CAPACITY_VALUE_RCS;         // 35000 in the reference CS

/*
| Maximum values allowed by the YASP Parser
*/
extern const long ATTCAP_MAX;
extern const long ATTCHCAP_MAX;
extern const long AVGRPCAP_MAX;
extern const long DTACAP_MAX;
extern const long DTACHCAP_MAX;
extern const long ELEMCAP_MAX;
extern const long ENTCAP_MAX;
extern const long ENTCHCAP_MAX;
extern const long EXGRPCAP_MAX;
extern const long EXNMCAP_MAX;
extern const long GRPCAP_MAX;
extern const long IDCAP_MAX;
extern const long IDREFCAP_MAX;
extern const long LKNMCAP_MAX;
extern const long LKSETCAP_MAX;
extern const long MAPCAP_MAX;
extern const long NOTCAP_MAX;
extern const long NOTCHCAP_MAX;
extern const long TOTALCAP_MAX;

#endif /* _CAPACITY_EH ********************************************************/
