/*-------------------------------------------------------------------------
                PROJECT YAO OBJECT SGML PARSER (OSGML)
                     Version 1.0 Alpha level 4.0
   An SGML Parser conforming to International Standard ISO 8879 --
                 Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

               INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------
//// capacity.h
///  Declarations for capacity
//   Pierre G. Richard 93/10/15 - Petrus Services and Consulting, Ltd.
  -------------------------------------------------------------------------*/
#ifndef _CAPACITY_H
#define _CAPACITY_H 1
/*
| The Capacity Class is designed to collect constant data
| -- fixed by the syntax -- relative to capacities.
| Hence, it does not include the capacity counters themselve.
*/
//******************************************************************************

#include "capacity.eh"  // enums

/*---------------+
| Capacity class |
+---------------*/
class Capacity {
public:
   /*-----------------+
   | Public Functions |
   +-----------------*/
   Capacity();
   Capacity(ApplicationHandle ahlAccess);

   unsigned long value_of(e_IxCapacity ix);       // Variant value
   unsigned long compute(e_IxCapacity ix, unsigned long *aulCapacityCount);
   static const char * const name_of(e_IxCapacity ix);
   boolean capa_chk(unsigned long * aulCapacityCount);

protected:
   /*--------------------+
   | Protected Variables |
   +--------------------*/
   unsigned long aulCapacityMax[CAP_MAX_SIZE];    // maximum values
   unsigned int auiCapacityPoint[CAP_MAX_SIZE];   // point per object
};

/*-----------------------------------------------------------------------------+
| NewCapacity class (while builing it)                                         |
+-----------------------------------------------------------------------------*/
class NewCapacity : public Capacity
{
public:
   unsigned long set_value(e_IxCapacity ix, unsigned long value);
   void check_consistency();
   void unload(ApplicationHandle ahlAccess, int iNamelen);
};

/*-- INLINES --*/
inline unsigned long Capacity::value_of(e_IxCapacity ix) {
   return aulCapacityMax[ix];
}
#endif /* _CAPACITY_H *********************************************************/
