/*-------------------------------------------------------------------------
                PROJECT YAO OBJECT SGML PARSER (OSGML)
                     Version 1.0 Alpha level 4.0
   An SGML Parser conforming to International Standard ISO 8879 --
                 Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

               INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------
//// chkambg.h
///  Declarations for chkambg
//   Pierre G. Richard 93/10/15 - Petrus Services and Consulting, Ltd.
  -------------------------------------------------------------------------*/
#ifndef _CHKAMBG_H
#define _CHKAMBG_H 1
//******************************************************************************

typedef ModelNode * Arc;

class CheckAmbiguities
{
public:
   /*-----------------+
   | Public functions |
   +-----------------*/
   CheckAmbiguities(
      ModelNode *pMnode,
      int iMaximumNodes,
      boolean isPcdataDuplicateArg,
      EntityHandler *pEh,
      const char *pszPcdataName
   );
   ~CheckAmbiguities();

private:
   /*--------------------+
   | Private definitions |
   +--------------------*/
   struct Graph {
      Arc *pArcStart; // next room free for arcs from Start-State (pArcStart)
      Arc *pArcFinal; // next room free for arcs from Final-State (pArcFinal)
   };

   /*-------------+
   | Private data |
   +-------------*/
   EntityHandler *pEh;
   Arc *aArcBuf;
   const char *pszPcdataName;
   Graph graph;
   boolean isPcdataDuplicate;
   boolean isLocationSaid;


   /*------------------+
   | Private functions |
   +------------------*/
   Arc * enter_arcs(
      Arc *pArcSourceFrom, Arc *pArcSourceTo,   // Source (arcs to be entered)
      Arc *pArcTargetFrom,                      // Target (where to enter them)
      Arc *pArcCompareFrom, Arc *pArcCompareTo  // Compared to (check redundancy)
   );
   void check_ambiguities(ModelNode *pMnode1, ModelNode *pMnode2);
   void analyse_graph(e_Connector conn, ModelNode *pMnode, Graph * pGraphGroup);
};
#endif /* _CHKAMBG_H **********************************************************/
