/*-------------------------------------------------------------------------
                PROJECT YAO OBJECT SGML PARSER (OSGML)
                     Version 1.0 Alpha level 4.0
   An SGML Parser conforming to International Standard ISO 8879 --
                 Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

               INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------
//// dlmstr.eh
///  Enumerations of dlmstr
//   Pierre G. Richard 93/10/15 - Petrus Services and Consulting, Ltd.
  -------------------------------------------------------------------------*/
#ifndef _DLMSTR_EH
#define _DLMSTR_EH 1
/*
| Indices to the Reference Delimiter Strings
*/
enum e_IxDlmstrRefer {      // Indices to aDlmstrRefer table
   AND_RDL_ix,      COM_RDL_ix,      CRO_RDL_ix,      DSC_RDL_ix,
   DSO_RDL_ix,      DTGC_RDL_ix,     DTGO_RDL_ix,     ERO_RDL_ix,
   ETAGO_RDL_ix,    GRPC_RDL_ix,     GRPO_RDL_ix,     LIT_RDL_ix,
   LITA_RDL_ix,     MDC_RDL_ix,      MDO_RDL_ix,      MINUS_RDL_ix,
   MSC_RDL_ix,      NET_RDL_ix,      OPT_RDL_ix,      OR_RDL_ix,
   PERO_RDL_ix,     PIC_RDL_ix,      PIO_RDL_ix,      PLUS_RDL_ix,
   REFC_RDL_ix,     REP_RDL_ix,      RNI_RDL_ix,      SEQ_RDL_ix,
   STAGO_RDL_ix,    TAGC_RDL_ix,     VI_RDL_ix,       MDO_DSO_RDL_ix,
   MSC_MDC_RDL_ix,
   NOT_FOUND_RDL_ix, RDL_MAX_SIZE = NOT_FOUND_RDL_ix  // last entries
};

/*
| Indices to the Variant Delimiter Strings
| Not *all* delimiters are included
*/
enum e_IxDlmstrVarnt {
   COM_VDL_ix,      CRO_VDL_ix,      ERO_VDL_ix,      ETAGO_VDL_ix,
   LIT_VDL_ix,      LITA_VDL_ix,     MDC_VDL_ix,      MDO_VDL_ix,
   MINUS_VDL_ix,    PERO_VDL_ix,     PIC_VDL_ix,      PIO_VDL_ix,
   REFC_VDL_ix,     RNI_VDL_ix,      STAGO_VDL_ix,    TAGC_VDL_ix,
   VI_VDL_ix,       MDO_DSO_VDL_ix,  MSC_MDC_VDL_ix,
   NOT_FOUND_VDL_ix, VDL_MAX_SIZE = NOT_FOUND_VDL_ix  // last entries
};

/*
| Indices to the Reference Delimiter Item table
*/
enum e_IxDlmitmRefer {
   AND_DLI_ix,      COM_DLI_ix,      CRO_DLI_ix,      DSC_DLI_ix,
   DSO_DLI_ix,      DTGC_DLI_ix,     DTGO_DLI_ix,     ERO_DLI_ix,
   ETAGO_DLI_ix,    GRPC_DLI_ix,     GRPO_DLI_ix,     LIT_DLI_ix,
   LITA_DLI_ix,     MDC_DLI_ix,      MDO_DLI_ix,      MINUS_DLI_ix,
   MSC_DLI_ix,      NET_DLI_ix,      OPT_DLI_ix,      OR_DLI_ix,
   PERO_DLI_ix,     PIC_DLI_ix,      PIO_DLI_ix,      PLUS_DLI_ix,
   REFC_DLI_ix,     REP_DLI_ix,      RNI_DLI_ix,      SEQ_DLI_ix,
   SHORTREF_DLI_ix, STAGO_DLI_ix,    TAGC_DLI_ix,     VI_DLI_ix,
   NOT_FOUND_DLI_ix, DLI_MAX_SIZE = NOT_FOUND_DLI_ix  // last entries
};

/*
| Indices to the Reference Double Delimiter Item table
*/
enum e_IxDDlmitmRefer {
   ERO_GRPO_DDLI_ix,   ETAGO_TAGC_DDLI_ix,    ETAGO_GRPO_DDLI_ix,
   MDO_COM_DDLI_ix,    MDO_DSO_DDLI_ix,       MDO_MDC_DDLI_ix,
   MSC_MDC_DDLI_ix,    PERO_GRPO_DDLI_ix,     STAGO_TAGC_DDLI_ix,
   STAGO_GRPO_DDLI_ix, MINUS_GRPO_DDLI_ix,    PLUS_GRPO_DDLI_ix,
   NOT_FOUND_DDLI_ix, DDLI_MAX_SIZE = NOT_FOUND_DDLI_ix  // last entries
};
#endif /* _DLMSTR_EH **********************************************************/
