/*-------------------------------------------------------------------------
                PROJECT YAO OBJECT SGML PARSER (OSGML)
                     Version 1.0 Alpha level 4.0
   An SGML Parser conforming to International Standard ISO 8879 --
                 Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

               INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------
//// element.eh
///  Enumerations related to element
//   Pierre G. Richard 93/10/15 - Petrus Services and Consulting, Ltd.
  -------------------------------------------------------------------------*/
#ifndef _ELEMENT_EH
#define _ELEMENT_EH 1

enum e_Minimize {     // Minimization field, when reporting an Element event
   NO_MNF = 0,        // No minimization applies
   EMPTY_ST_MNF,      // EMPTY start-tag (STAGO-TAGC)
   UNCL_ST_MNF,       // Unclosed start-tag
   NET_ST_MNF,        // NET-enabling start-tag
   EMPTY_ET_MNF,      // EMPTY end-tag (ETAGO-TAGC)
   UNCL_ET_MNF,       // Unclosed end-tag
   NULL_ET_MNF,       // NULL end-tag (NET)
   DATA_ET_MNF        // DATATAG end-tag
};

enum e_InferBy {      // "inferred_by" field - markup inferred by:
   NO_IMF = 0,        // This start/end tag was not inferred (parsed)
   DOC_IMF,           // Start of document instance set
   DATA_IMF,          // Data
   STG_IMF,           // Start-tag (by_elem_p)
   ETG_IMF,           // End-tag (by_elem_p)
   EDTG_IMF,          // End-DataTag (by_elem_p)
   EOF_IMF            // End of File
};

enum e_Dcdata {                 // Values taken by the elem.is.dcdata field:
   DENY_DCDATA = 0x00,          // Is *not* Declared Character Data
   NONR_DCDATA = 0x01,          // Non Replaceable Character Data (i.e.: CDATA)
   RPLC_DCDATA = 0x02           // Replaceable Character Data (i.e.: RCDATA)
};

#define OMISSIBLE   0x01
#define REPEATABLE  0x02

enum e_Occurence {             // OCCUR:
   NULL_OCCUR = 0,
   OPT_OCCUR = OMISSIBLE,
   PLUS_OCCUR = REPEATABLE,
   REP_OCCUR = OMISSIBLE | REPEATABLE
};

enum e_Connector {             // CONN:
   NULL_CONN = 0,
   AND_CONN,
   SEQ_CONN,
   OR_CONN
};
#endif /* _ELEMENT_EH *********************************************************/
