/*-------------------------------------------------------------------------
                PROJECT YAO OBJECT SGML PARSER (OSGML)
                     Version 1.0 Alpha level 4.0
   An SGML Parser conforming to International Standard ISO 8879 --
                 Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

               INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------
//// event.eh
///  Enumerations of event
//   Pierre G. Richard 94/03/17 - Petrus Services and Consulting, Ltd.
  -------------------------------------------------------------------------*/
#ifndef _EVENT_EH
#define _EVENT_EH 1

enum e_Event {
   // --- Primary events ---
   EOP_EV = 0,
   SGML_START_EV,
   SGML_END_EV,
   DOCTYPE_START_EV,
   DOCTYPE_END_EV,
   LINKTYPE_START_EV,
   LINKTYPE_END_EV,
   SECTION_START_EV,
   SECTION_END_EV,
   ELEMENT_START_EV,
   ELEMENT_END_EV,
   DATA_EV,
   RE_EV,
   ENTITY_START_EV,
   ENTITY_END_EV,
   PI_EV,
   COMMENT_EV,
   ERROR_EV,

   // --- Decomposed events ---
   ATT_NAME_EV,
   DATA_ATT_NAME_EV,
   ATT_VAL_IMPLIED_EV,
   ATT_VAL_INVALID_EV,
   ATT_VAL_ENTITY_EV,
   ATT_VAL_ID_EV,
   ATT_VAL_IDREF_EV,
   ATT_VAL_NAME_EV,
   ATT_VAL_NMTOKEN_EV,
   ATT_VAL_NUMBER_EV,
   ATT_VAL_NUTOKEN_EV,
   ATT_VAL_CDATA_EV,
   ATT_VAL_COMPOSITE_EV,
   ATT_VAL_COMPOSITE_SDATA_EV,
   ATT_VAL_COMP_DATA_EV,
   ATT_VAL_COMP_CDATA_EV,
   ATT_VAL_COMP_SDATA_EV,
   ATT_VAL_TOKENS_EV,
   ATT_VAL_TOKEN_ENTITY_EV,
   ATT_VAL_TOKEN_ID_EV,
   ATT_VAL_TOKEN_IDREF_EV,
   ATT_VAL_TOKEN_NAME_EV,
   ATT_VAL_TOKEN_NMTOKEN_EV,
   ATT_VAL_TOKEN_NUMBER_EV,
   ATT_VAL_TOKEN_NUTOKEN_EV,
   ATT_VAL_NOTATION_EV,
   ATT_VAL_NMTOK_IN_GROUP_EV,
   ENT_INT_SGML_EV,
   ENT_INT_CDATA_EV,
   ENT_INT_SDATA_EV,
   ENT_INT_PI_EV,
   ENT_INT_STARTTAG_EV,
   ENT_INT_ENDTAG_EV,
   ENT_INT_MS_EV,
   ENT_INT_MD_EV,
   ENT_EXT_SGML_EV,
   ENT_EXT_SUBDOC_EV,
   ENT_EXT_CDATA_EV,
   ENT_EXT_NDATA_EV,
   ENT_EXT_SDATA_EV,
   PUBLIC_ID_EV,
   SYSTEM_ID_EV,
   SYSTEM_ID_OMITTED_EV,
   ENT_NOTATION_EV,
   ALL_EV,                          // must be next to last entry
   EV_MAX_SIZE = ALL_EV             // must be last entry
};

#endif /* _EVENT_EH ***********************************************************/
