/*-------------------------------------------------------------------------
                PROJECT YAO OBJECT SGML PARSER (OSGML)
                     Version 1.0 Alpha level 4.0
   An SGML Parser conforming to International Standard ISO 8879 --
                 Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

               INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------
//// externid.eh
///  Enumerations of externid
//   Pierre G. Richard 93/10/15 - Petrus Services and Consulting, Ltd.
  -------------------------------------------------------------------------*/
#ifndef _EXTERNID_EH
#define _EXTERNID_EH 1

enum e_TextClass {         // XFC: Class Field
   INVALID_XFC = 0,        // Invalid, or Irrelevant
   CAPACITY_XFC,           // capacity set
   CHARSET_XFC,            // character data
   DOCUMENT_XFC,           // sgml document
   DTD_XFC,                // document type declaration subset
   ELEMENTS_XFC,           // element set
   ENTITIES_XFC,           // entity set
   LPD_XFC,                // link type declaration subset
   NONSGML_XFC,            // non sgml data entity
   NOTATION_XFC,           // character data
   SHORTREF_XFC,           // short reference set
   SUBDOC_XFC,             // sgml subdocument entity
   SYNTAX_XFC,             // concrete syntax
   TEXT_XFC,               // sgml text entity
                           // -- Parser Specific --
   UTODTR_XFC,             // utility dtd to read (odt)
   UTODTW_XFC,             // utility dtd to write (odt)
   UTSYNU_XFC,             // utility user-modified ocs
   UTSYNL_XFC,             // utility local-system ocs
   UTSYNR_XFC,             // utility refcon-system ocs
   PRIMARY_XFC,            // primary entity
   UTOLTR_XFC,             // utility ltd to read (olt)
   UTOLTW_XFC              // utility ltd to write (olt)
};
#endif /* _EXTERNID_EH ********************************************************/
