/*-------------------------------------------------------------------------
                PROJECT YAO OBJECT SGML PARSER (OSGML)
                     Version 1.0 Alpha level 4.0
   An SGML Parser conforming to International Standard ISO 8879 --
                 Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

               INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------
//// gendef.h
///  General declarations
//   Pierre G. Richard 93/10/15 - Petrus Services and Consulting, Ltd.
  -------------------------------------------------------------------------*/
#ifndef _GENDEF_H
#define _GENDEF_H 1
//******************************************************************************
#include <stdlib.h>
#include <string.h>
#include <limits.h>

#if (INT_MAX == SHRT_MAX)
#define OCS_BANNER "\025OSGML OCS/V0.42/16BIT";
#define ODT_BANNER "\025OSGML ODT/V0.42/16BIT";
#else
#define OCS_BANNER "\025OSGML OCS/V0.42/32BIT";
#define ODT_BANNER "\025OSGML ODT/V0.42/32BIT";
#endif

#if ((__BCPLUSPLUS__ == 0x310) || (__BCPLUSPLUS__ == 0x320))
   // Borland C++ 3.1 and 4.0 do not know about place_address in operator new
   inline void * operator new(size_t, void *p) { return p; }
   // BORLAND C++ 4.0 needs an _export / _import for windows DLL's
#else
   #define _export
   #define _import
#endif

#ifdef __GNUC__
#define fpos_t long            // GNU: fpos_t ANSI structure not recognized
#endif

#ifdef __GNUC__ 
typedef bool boolean ;
#else
enum boolean { FALSE = 0,  TRUE = 1 };
#endif

#define MAX_ALLOC (((size_t) ~0) - 256)

/*-----------------------------------------------------------------------------+
| Application Handle                                                           |
+-----------------------------------------------------------------------------*/
union ApplicationHandle {   // AHL: to pass any kind of file handle */
   void *p;                 // either pointer
   int   i;                 // or identifier
};

#if (INT_MAX == SHRT_MAX)
// allow the difference of pointers in arrays larger than 32K
#define diffptr(p, q) \
((int)(((*((unsigned far *)&(p)))-(*((unsigned far *)&(q)))) / sizeof(*(q))))

#else
#define diffptr(p, q)  ((p) - (q))
#endif


/*------------------------------------------------------------duplicate_string-+
| Just because strdup is not ANSI.  Will do a class someday...                 |
+-----------------------------------------------------------------------------*/
inline char *duplicate_string(const char *pszSource)
{
   char *pszTarget;
   int iLength = strlen(pszSource);
   memcpy(pszTarget = (char *)malloc(iLength+1), pszSource, iLength+1);
   return pszTarget;
}

#endif /* _GENDEF_H ***********************************************************/

