/*-------------------------------------------------------------------------
                PROJECT YAO OBJECT SGML PARSER (OSGML)
                     Version 1.0 Alpha level 4.0
   An SGML Parser conforming to International Standard ISO 8879 --
                 Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

               INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------
//// lextoken.eh
///  Enumerations of lextoken
//   Pierre G. Richard 93/10/15 - Petrus Services and Consulting, Ltd.
  -------------------------------------------------------------------------*/
#ifndef _LEXTK_EH
#define _LEXTK_EH 1

/*-----------------------------------------------------------------------------+
| Token numbers are associated to SGML keywords and grouped in an enum type.   |
| This permits a strongest type checking (for compilers that allow it).        |
+-----------------------------------------------------------------------------*/
enum e_LexToken {            // TK:
   NOT_FOUND_TK,             // This one reserved
   AND_TK,                   // AND delimiter
   ANY_TK,                   // "ANY" keyword
   ATTLIST_TK,               // "ATTLIST" keyword
   CDATA_TK,                 // "CDATA" keyword
   COM_TK,                   // COM delimiter
   CONTROLS_TK,              // "CONTROLS" keyword
   CRO_TK,                   // CRO delimiter
   DOCTYPE_TK,               // "DOCTYPE" keyword
   DOCUMENT_TK,              // "DOCUMENT" keyword
   DSC_TK,                   // DSC delimiter
   DSO_TK,                   // DSO delimiter
   DTGC_TK,                  // DTGC delimiter
   DTGO_TK,                  // DTGO delimiter
   ELEMENT_TK,               // "ELEMENT" keyword
   EMPTY_TK,                 // "EMPTY" keyword
   ENTITY_TK,                // "ENTITY" keyword
   ERO_GRPO_TK,              // ERO_GRPO double-delimiter
   ERO_TK,                   // ERO delimiter
   ETAGO_TK,                 // ETAGO delimiter
   ETAGO_GRPO_TK,            // ETAGO_GRPO double-delimiter
   ETAGO_TAGC_TK,            // ETAGO_TAGC double-delimiter
   GRPC_TK,                  // GRPC delimiter
   GRPO_TK,                  // GRPO delimiter
   IDLINK_TK,                // "IDLINK" keyword
   INSTANCE_TK,              // "INSTANCE" keyword
   LINK_TK,                  // "LINK" keyword
   LINKTYPE_TK,              // "LINKTYPE" keyword
   LIT_TK,                   // LIT delimiter
   LITA_TK,                  // LITA delimiter
   MDC_TK,                   // MDC delimiter
   MDO_TK,                   // MDO delimiter
   MDO_COM_TK,               // MDO_COM double-delimiter
   MDO_DSO_TK,               // MDO_DSO double-delimiter
   MDO_MDC_TK,               // MDO_MDC double-delimiter
   MINUS_TK,                 // MINUS delimiter
   MINUS_GRPO_TK,            // MINUS_GRPO double-delimiter
   MSC_MDC_TK,               // MSC_MDC delimiter
   MSC_TK,                   // MSC delimiter
   NET_TK,                   // NET delimiter
   NO_TK,                    // "NO" keyword
   NONE_TK,                  // "NONE" keyword
   NOTATION_TK,              // "NOTATION" keyword
   OPT_TK,                   // OPT delimiter
   OR_TK,                    // OR delimiter
   PERO_GRPO_TK,             // PERO_GRPO double-delimiter
   PERO_TK,                  // PERO double-delimiter
   PIC_TK,                   // PIC double-delimiter
   PIO_TK,                   // PIO double-delimiter
   PLUS_TK,                  // PLUS double-delimiter
   PLUS_GRPO_TK,             // PLUS_GRPO double-delimiter
   PUBLIC_TK,                // "PUBLIC" keyword
   RCDATA_TK,                // "RCDATA" keyword
   REFC_TK,                  // REFC double-delimiter
   REGION_TK,                // "REGION" keyword
   REP_TK,                   // REP double-delimiter
   RNI_TK,                   // "RNI" keyword
   SEQ_TK,                   // "SEQ" keyword
   SHORTREF_TK,              // "SHORTREF" keyword
   STAGO_GRPO_TK,            // STAGO_GRPO double-delimiter
   STAGO_TAGC_TK,            // STAGO_TAGC double-delimiter
   STAGO_TK,                 // STAGO double-delimiter
   SYSTEM_TK,                // "SYSTEM" keyword
   TAGC_TK,                  // TAGC double-delimiter
   USEMAP_TK,                // "USEMAP" keyword
   VI_TK,                    // VI double-delimiter
   YES_TK,                   // "YES" keyword
   SR_first,                 // 1st ShortRef delimiter
   /*...*/                   // (and so on...)
   SR_last = SR_first + 5000 // Need to do this to reserve enough bits in C++
};
#endif /* _LEXTK_EH ***********************************************************/
