/*-------------------------------------------------------------------------
                PROJECT YAO OBJECT SGML PARSER (OSGML)
                     Version 1.0 Alpha level 4.0
   An SGML Parser conforming to International Standard ISO 8879 --
                 Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

               INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------
//// notadcl.h
///  Declarations for notadcl
//   Pierre G. Richard 94/02/02 - Petrus Services and Consulting, Ltd.
  -------------------------------------------------------------------------*/
#ifndef _NOTADCL_H
#define _NOTADCL_H 1

/*-----------------------------------------------------------------------------+
| Notation declaration                                                         |
+-----------------------------------------------------------------------------*/
class NotationDcl :
   private virtual PrologDcl           // IS_A?
{
public:
   void parse();
};

/*-----------------------------------------------------------------------------+
| Specific class while compiling                                               |
+-----------------------------------------------------------------------------*/
struct NotationBlock {          // NB: value_of(pExpnhashNotation)
   union {
      AttributeNode *pAnode;    // AttributeNode
      int ixAttrep;             // index in AttributeRep array (temporary)
   };
   union {
      ExternId *pExid;          // External id pointer
      int ixNcb;                // ix in NotationType array (Temporary)
   };
   boolean pile_up(
      StringKeeper& sk, const char *pszName,
      NotationType*& pNcbMP, const NotationType* const aNcbTable,
      AttributeRep*& pAttrepMP, const AttributeRep* const aAttrepTable,
      Component*& pCompoMP, const Component* const aCompoTable
   );
};
#endif /* _NOTADCL_H **********************************************************/
