/*-------------------------------------------------------------------------
                PROJECT YAO OBJECT SGML PARSER (OSGML)
                     Version 1.0 Alpha level 4.0
   An SGML Parser conforming to International Standard ISO 8879 --
                 Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

               INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------
//// notation.c
///  Notation class
//   Pierre G. Richard 94/01/04 - Petrus Services and Consulting, Ltd.
  -------------------------------------------------------------------------*/
//******************************************************************************

/*--------------+
| Include Files |
+--------------*/
#include <stdlib.h>
#include <stdio.h>
#include "gendef.h"
#include "notation.h"
#include "attrib.h"

/*---------------------------------------------------------------relocate_pile-+
| Relocate iMaxEntries NotationType objects piled_up in an array               |
+-----------------------------------------------------------------------------*/
void NotationType::relocate_pile(
   unsigned int iMaxEntries,
   AttributeRep *aAttrepTable,
   char *strbuf
)
{
   NotationType *pNcb = this;

   for (int i=0; i < iMaxEntries; ++i, ++pNcb) {
      pNcb->exid.relocate(strbuf);
      /*
      | This is the deflt ATL associated: maybe we'll need it some day ?
      */
      if (pNcb->ixAttrep == -1) {
         pNcb->aAttrepDefList = 0;
      }else {
         pNcb->aAttrepDefList = aAttrepTable + pNcb->ixAttrep;
      }
   }
}

/*--------------------------------------------------------------attribute_list-+
| Build the attribute definition list                                          |
+-----------------------------------------------------------------------------*/
void NotationType::attribute_list(AttributeList& attlist) const {
   attlist.build(aAttrepDefList);
}

/*---------------------------------------------------------------------display-+
|                                                                              |
+-----------------------------------------------------------------------------*/
void NotationType::display(ParseState *pPrsstat, int iIndent) const
{
   fprintf(stderr, "%*.sInterpreter: (%s) ", iIndent+6, " ", exid.name());
   if (exid.is_unchecked()) {           // `find' has not been issued
      fprintf(stderr, "\"%s %s\"\n", exid.public_id(), exid.system_id());
   }else {                              // `find' has been issued
      if (exid.is_unknown_on_system()) {
         fprintf(stderr, "*unresolved*\n");
      }else {
         fprintf(stderr, "\"%s\"\n", exid.poem_id_handle().p);
      }
   }
   AttributeList attl(this);
   attl.display(pPrsstat, iIndent+6+10);
}
/*============================================================================*/
