/*-------------------------------------------------------------------------
                PROJECT YAO OBJECT SGML PARSER (OSGML)
                     Version 1.0 Alpha level 4.0
   An SGML Parser conforming to International Standard ISO 8879 --
                 Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

               INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------
//// notation.h
///  Declarations for notation
//   Pierre G. Richard 93/10/15 - Petrus Services and Consulting, Ltd.
  -------------------------------------------------------------------------*/
#ifndef _NOTATION_H
#define _NOTATION_H 1
/*
| This H file defines the structure associated to the Notation Declaration
*/
//******************************************************************************

#include "externid.h"   // can be seen as a base class

class ParseState;
class AttributeRep;
class AttributeList;

/*-----------------------------------------------------------------------------+
| Notation Type (NCB)                                                          |
+-----------------------------------------------------------------------------*/
//***>NOTE: C++ derivation not used, to make sure the exid occurs first.

class NotationType {                // NCB: Notation
   friend class NotationBlock;      // pile_up();
public:
   void relocate_pile(              // real constructor
      unsigned int iMaxEntries,
      AttributeRep *aAttrepTable,
      char *strbuf
   );
   void attribute_list(AttributeList &attlist) const;
   const ExternId * external_id() const;
   void display(ParseState *pPrsstat, int iIndent) const;
private:
   ExternId exid;
   union {
      AttributeRep *aAttrepDefList; // Attribute Definition List
      int ixAttrep;                 // (ATTREP array index, when unloaded)
   };
   NotationType();                  // Constructor (undefined)
   ~NotationType();                 // Destructor (undefined)
};

/*-- INLINES --*/
inline const ExternId * NotationType::external_id() const { return &exid; };

#endif /* _NOTATION_H *********************************************************/
