/*-------------------------------------------------------------------------
                PROJECT YAO OBJECT SGML PARSER (OSGML)
                     Version 1.0 Alpha level 4.0
   An SGML Parser conforming to International Standard ISO 8879 --
                 Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

               INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------
//// prsmode.eh
///  Enumerations of prsmode
//   Pierre G. Richard 93/10/15 - Petrus Services and Consulting, Ltd.
  -------------------------------------------------------------------------*/
#ifndef _PRSMODE_EH
#define _PRSMODE_EH 1

/*------------------+
| Recognition Modes |
+------------------*/
enum e_RecognitionMode {
   CON_MODE,    // As indicated in ISO 8879, 9.6.1
   DS_MODE,     // As indicated in ISO 8879, 9.6.1
   GRP_MODE,    // As indicated in ISO 8879, 9.6.1
   LITC_MODE,   // literal with replaceable character data
   MD_MODE,     // As indicated in ISO 8879, 9.6.1
   TAG_MODE,    // As indicated in ISO 8879, 9.6.1
   ASL_MODE,    // attribute specification list started with DSO
   LITP_MODE,   // literal with replaceable parameter data
   RCD_MODE,    // replaceable character data (RCDATA) elem declared content
   FCD_MODE,    // fixed character data (CDATA) elem declared content
   RCDMS_MODE,  // replaceable character data in Marked Section (RCDATA MS)
   FCDMS_MODE,  // fixed character data in Marked Section (CDATA MS)
   IGNMS_MODE,  // Ignored Marked Section (IGNORE MS)
   INI_MODE,    // when the parse of the document starts
   NBR_OF_MODES // ** This must be the last entry **
};
#endif /* _PRSMODE_EH **********************************************************/
