/*-------------------------------------------------------------------------
                PROJECT YAO OBJECT SGML PARSER (OSGML)
                     Version 1.0 Alpha level 4.0
   An SGML Parser conforming to International Standard ISO 8879 --
                 Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

               INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------
//// quantity.eh
///  Enumerations of quantity
//   Pierre G. Richard 93/10/15 - Petrus Services and Consulting, Ltd.
  -------------------------------------------------------------------------*/
#ifndef _QUANTITY_EH
#define _QUANTITY_EH 1

/*------------------------------+
| Indeces to the Quantity Table |
+------------------------------*/
enum e_IxQuantity {
   ATTCNT_QTY_ix,
   ATTSPLEN_QTY_ix,
   BSEQLEN_QTY_ix,
   DTAGLEN_QTY_ix,
   DTEMPLEN_QTY_ix,
   ENTLVL_QTY_ix,
   GRPCNT_QTY_ix,
   GRPGTCNT_QTY_ix,
   GRPLVL_QTY_ix,
   LITLEN_QTY_ix,
   NAMELEN_QTY_ix,
   NORMSEP_QTY_ix,
   PILEN_QTY_ix,
   TAGLEN_QTY_ix,
   TAGLVL_QTY_ix,
   NOT_FOUND_QTY_ix, QTY_MAX_SIZE = NOT_FOUND_QTY_ix  // must be last entries
};

/*
| Values from the Reference Concrete Syntax
*/
enum { ATTCNT_RCS =     40 };
enum { ATTSPLEN_RCS =  960 };
enum { BSEQLEN_RCS =   960 };
enum { DTAGLEN_RCS =    16 };
enum { DTEMPLEN_RCS =   16 };
enum { ENTLVL_RCS =     16 };
enum { GRPCNT_RCS =     32 };
enum { GRPGTCNT_RCS =   96 };
enum { GRPLVL_RCS =     16 };
enum { LITLEN_RCS =    240 };
enum { NAMELEN_RCS =     8 };
enum { NORMSEP_RCS =     2 };
enum { PILEN_RCS =     240 };
enum { TAGLEN_RCS =    960 };
enum { TAGLVL_RCS =     24 };

/*
| Maximum values allowed by the YASP Parser
*/
enum { ATTCNT_MAX =            180 };
enum { ATTSPLEN_MAX =        16000 };
enum { BSEQLEN_MAX =   BSEQLEN_RCS };
enum { DTAGLEN_MAX =   DTAGLEN_RCS };
enum { DTEMPLEN_MAX = DTEMPLEN_RCS };
enum { ENTLVL_MAX =             40 };
#if (INT_MAX == SHRT_MAX)
enum { GRPCNT_MAX =            100 };
enum { GRPGTCNT_MAX =          300 };
#else
enum { GRPCNT_MAX =            500 };
enum { GRPGTCNT_MAX =         1000 };
#endif
enum { GRPLVL_MAX =     GRPLVL_RCS };
enum { LITLEN_MAX =           2400 };
enum { NAMELEN_MAX =            32 };
enum { NORMSEP_MAX =         16000 };
enum { PILEN_MAX =            2400 };
enum { TAGLEN_MAX =          16000 };
enum { TAGLVL_MAX =             40 };

#endif /* _QUANTITY_EH ********************************************************/
