/*-------------------------------------------------------------------------
                PROJECT YAO OBJECT SGML PARSER (OSGML)
                     Version 1.0 Alpha level 4.0
   An SGML Parser conforming to International Standard ISO 8879 --
                 Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

               INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------
//// quantity.h
///  Declarations for quantity
//   Pierre G. Richard 93/10/15 - Petrus Services and Consulting, Ltd.
  -------------------------------------------------------------------------*/
#ifndef _QUANTITY_H
#define _QUANTITY_H 1
//******************************************************************************

#include "quantity.eh"  // enums

class Quantity
{
public:
   /*-----------------+
   | Public Functions |
   +-----------------*/
   Quantity();
   Quantity(ApplicationHandle ahlAccess);

   int value_of(e_IxQuantity ix);         // Variant value
   static const char * const name_of(e_IxQuantity ix);
   boolean read_and_check_quantity(ApplicationHandle ahlAccess);
   void unload(ApplicationHandle ahlAccess);

protected:
   /*--------------------+
   | Protected Variables |
   +--------------------*/
   unsigned int qntytab[QTY_MAX_SIZE];
};

/*-----------------------------------------------------------------------------+
| NewQuantity class (while builing it)                                         |
+-----------------------------------------------------------------------------*/
class NewQuantity : public Quantity
{
public:
   boolean set_value(e_IxQuantity ix, unsigned long value);
};

/*--------------------------------------------------------------------value_of-+
| -- INVARIANTS --                                                             |
| -- INPUT --                                                                  |
| -- PRECONDITION --                                                           |
| -- OUTPUT --                                                                 |
| -- POSTCONDITION --                                                          |
+-----------------------------------------------------------------------------*/
inline int Quantity::value_of(e_IxQuantity ix)  { return qntytab[ix]; }

#endif /* _QUANTITY_H *********************************************************/
