/*-------------------------------------------------------------------------
                PROJECT YAO OBJECT SGML PARSER (OSGML)
                     Version 1.0 Alpha level 4.0
   An SGML Parser conforming to International Standard ISO 8879 --
                 Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

               INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------
//// refstr.h
///  Declarations for refstr
//   Pierre G. Richard 93/10/15 - Petrus Services and Consulting, Ltd.
  -------------------------------------------------------------------------*/
#ifndef _REFSTR_H
#define _REFSTR_H 1
/*
| ReferenceString contains all keywords and constants of the concrete syntax
*/
//******************************************************************************
#include "errorh.h"     // to define e_ErrorCode

#include "rsvname.eh"   // enums
#include "dlmstr.eh"
#include "lextoken.eh"
#include "quantity.eh"
#include "capacity.eh"

class DelimiterString;
class ReservedName;
union KeyWord {           // Is an ordinary union to define Varnt tables
   char const *p;
   unsigned int ofs;
};
struct DelimiterItem;
struct DoubleDelimiterItem;

class ReferenceString {
   friend DelimiterString;
   friend ReservedName;

public:
   static void get_index(const char *pszName, e_IxRsvnameVarnt * const pix);
   static void get_index(const char *pszName, e_IxRsvnameRefer * const pix);
   static void get_index(const char *pszName, e_IxDlmitmRefer * const pix);
   static void get_index(const char *pszName, e_IxQuantity * const pix);
   static void get_index(const char *pszName, e_IxCapacity * const pix);
   static const char * ISO8879_banner();
   static e_ErrorCode clearance_to_replace(
      const char *pszName, e_IxRsvnameVarnt * const pix
   );
   static e_LexToken token_of(const e_IxDlmitmRefer ix);
   static e_LexToken token_of(const e_IxDDlmitmRefer ix);
   static e_LexToken delim1_token_of(const e_IxDDlmitmRefer ix);
   static e_LexToken delim2_token_of(const e_IxDDlmitmRefer ix);
   static const char * value_of(const e_IxDlmitmRefer ix);
   static unsigned int recognition_modes_of(const e_IxDlmitmRefer ix);
   static unsigned int recognition_modes_of(const e_IxDDlmitmRefer ix);
   static e_IxDlmstrVarnt delim_index_of(const e_IxDlmitmRefer ix);

private:
   static const char * get_achReferNameValue(const int i);
   static KeyWord * get_aKywdVarntNameValues();
   static const char * const * get_achReferDlmValues();
   static KeyWord * get_aKywdVarntDlmValues();
};
#endif /* _REFSTR_H **********************************************************/
