/*-------------------------------------------------------------------------
                PROJECT YAO OBJECT SGML PARSER (OSGML)
                     Version 1.0 Alpha level 4.0
   An SGML Parser conforming to International Standard ISO 8879 --
                 Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

               INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------
//// rsvname.eh
///  Enumerations of rsvname
//   Pierre G. Richard 93/10/15 - Petrus Services and Consulting, Ltd.
  -------------------------------------------------------------------------*/
#ifndef _RSVNAME_EH
#define _RSVNAME_EH 1
/*
| Indices to the Reference Reserved Names
*/
enum e_IxRsvnameRefer {      // Indices to aRsvnameRefer table
   AND_RRN_ix,      ANY_RRN_ix,      APPINFO_RRN_ix,  ASN1_RRN_ix,
   ATTCAP_RRN_ix,   ATTCHCAP_RRN_ix, ATTCNT_RRN_ix,   ATTLIST_RRN_ix,
   ATTSPLEN_RRN_ix, AVGRPCAP_RRN_ix, BASESET_RRN_ix,  BSEQLEN_RRN_ix,
   CAPACITY_RRN_ix, CDATA_RRN_ix,    CHANGES_RRN_ix,  CHARSET_RRN_ix,
   COM_RRN_ix,      CONCUR_RRN_ix,   CONREF_RRN_ix,   CONTROLS_RRN_ix,
   CRO_RRN_ix,      CURRENT_RRN_ix,  DATATAG_RRN_ix,  DEFAULT_RRN_ix,
   DELIM_RRN_ix,    DELIMLEN_RRN_ix, DESCSET_RRN_ix,  DOCTYPE_RRN_ix,
   DOCUMENT_RRN_ix, DSC_RRN_ix,      DSO_RRN_ix,      DTAGLEN_RRN_ix,
   DTD_RRN_ix,      DTEMPLEN_RRN_ix, DTGC_RRN_ix,     DTGO_RRN_ix,
   ELEMCAP_RRN_ix,  ELEMENT_RRN_ix,  ELEMENTS_RRN_ix, EMPTY_RRN_ix,
   ENDTAG_RRN_ix,   ENTCAP_RRN_ix,   ENTCHCAP_RRN_ix, ENTITIES_RRN_ix,
   ENTITY_RRN_ix,   ENTLVL_RRN_ix,   ERO_RRN_ix,      ETAGO_RRN_ix,
   EXCLUDE_RRN_ix,  EXGRPCAP_RRN_ix, EXNMCAP_RRN_ix,  EXPLICIT_RRN_ix,
   FEATURES_RRN_ix, FIXED_RRN_ix,    FORMAL_RRN_ix,   FUNCHAR_RRN_ix,
   FUNCTION_RRN_ix, GENERAL_RRN_ix,  GRPC_RRN_ix,     GRPCAP_RRN_ix,
   GRPCNT_RRN_ix,   GRPGTCNT_RRN_ix, GRPLVL_RRN_ix,   GRPO_RRN_ix,
   ID_RRN_ix,       IDCAP_RRN_ix,    IDLINK_RRN_ix,   IDREF_RRN_ix,
   IDREFCAP_RRN_ix, IDREFS_RRN_ix,   IGNORE_RRN_ix,   IMPLICIT_RRN_ix,
   IMPLIED_RRN_ix,  INCLUDE_RRN_ix,  INITIAL_RRN_ix,  INSTANCE_RRN_ix,
   LCNMCHAR_RRN_ix, LCNMSTRT_RRN_ix, LINK_RRN_ix,     LINKTYPE_RRN_ix,
   LIT_RRN_ix,      LITA_RRN_ix,     LITLEN_RRN_ix,   LKNMCAP_RRN_ix,
   LKSETCAP_RRN_ix, LPD_RRN_ix,      MAPCAP_RRN_ix,   MD_RRN_ix,
   MDC_RRN_ix,      MDO_RRN_ix,      MINIMIZE_RRN_ix, MINUS_RRN_ix,
   MODEL_RRN_ix,    MS_RRN_ix,       MSC_RRN_ix,      MSICHAR_RRN_ix,
   MSOCHAR_RRN_ix,  MSSCHAR_RRN_ix,  NAME_RRN_ix,     NAMECASE_RRN_ix,
   NAMELEN_RRN_ix,  NAMES_RRN_ix,    NAMING_RRN_ix,   NDATA_RRN_ix,
   NET_RRN_ix,      NMTOKEN_RRN_ix,  NMTOKENS_RRN_ix, NO_RRN_ix,
   NONE_RRN_ix,     NONSGML_RRN_ix,  NORMSEP_RRN_ix,  NOTATION_RRN_ix,
   NOTCAP_RRN_ix,   NOTCHCAP_RRN_ix, NUMBER_RRN_ix,   NUMBERS_RRN_ix,
   NUTOKEN_RRN_ix,  NUTOKENS_RRN_ix, O_RRN_ix,        OMITTAG_RRN_ix,
   OPT_RRN_ix,      OR_RRN_ix,       OTHER_RRN_ix,    PACK_RRN_ix,
   PCDATA_RRN_ix,   PERO_RRN_ix,     PI_RRN_ix,       PIC_RRN_ix,
   PILEN_RRN_ix,    PIO_RRN_ix,      PLUS_RRN_ix,     POSTLINK_RRN_ix,
   PUBLIC_RRN_ix,   QUANTITY_RRN_ix, RANK_RRN_ix,     RCDATA_RRN_ix,
   RE_RRN_ix,       REFC_RRN_ix,     REP_RRN_ix,      REQUIRED_RRN_ix,
   RESTORE_RRN_ix,  RNI_RRN_ix,      RS_RRN_ix,       SCOPE_RRN_ix,
   SDATA_RRN_ix,    SDIF_RRN_ix,     SEPCHAR_RRN_ix,  SEQ_RRN_ix,
   SEQUENCE_RRN_ix, SGML_RRN_ix,     SGMLREF_RRN_ix,  SHORTREF_RRN_ix,
   SHORTTAG_RRN_ix, SHUNCHAR_RRN_ix, SIMPLE_RRN_ix,   SPACE_RRN_ix,
   SRCNT_RRN_ix,    SRLEN_RRN_ix,    STAGO_RRN_ix,    STARTTAG_RRN_ix,
   SUBDOC_RRN_ix,   SWITCHES_RRN_ix, SYNTAX_RRN_ix,   SYSTEM_RRN_ix,
   TAB_RRN_ix,      TAGC_RRN_ix,     TAGLEN_RRN_ix,   TAGLVL_RRN_ix,
   TEMP_RRN_ix,     TEXT_RRN_ix,     TOTALCAP_RRN_ix, UCNMCHAR_RRN_ix,
   UCNMSTRT_RRN_ix, UNPACK_RRN_ix,   UNUSED_RRN_ix,   USELINK_RRN_ix,
   USEMAP_RRN_ix,   VALIDATE_RRN_ix, VI_RRN_ix,       YES_RRN_ix,
   NOT_FOUND_RRN_ix, RRN_MAX_SIZE = NOT_FOUND_RRN_ix  // must be last entries
};

/*
| Indices to the Variant Reserved Names
| Not all names are defined.
| Only the ones occuring in Prolog and Instance
*/
enum e_IxRsvnameVarnt {    // Indices to aRsvnameVarnt table
   ANY_VRN_ix,      ATTLIST_VRN_ix,  CAPACITY_VRN_ix, CDATA_VRN_ix,
   CHARSET_VRN_ix,  CONREF_VRN_ix,   CURRENT_VRN_ix,  DEFAULT_VRN_ix,
   DOCTYPE_VRN_ix,  DOCUMENT_VRN_ix, DTD_VRN_ix,      ELEMENT_VRN_ix,
   ELEMENTS_VRN_ix, EMPTY_VRN_ix,    ENDTAG_VRN_ix,   ENTITIES_VRN_ix,
   ENTITY_VRN_ix,   FIXED_VRN_ix,    ID_VRN_ix,       IDLINK_VRN_ix,
   IDREF_VRN_ix,    IDREFS_VRN_ix,   IGNORE_VRN_ix,   IMPLIED_VRN_ix,
   INCLUDE_VRN_ix,  INITIAL_VRN_ix,  LINK_VRN_ix,     LINKTYPE_VRN_ix,
   LPD_VRN_ix,      MD_VRN_ix,       MS_VRN_ix,       NAME_VRN_ix,
   NAMES_VRN_ix,    NDATA_VRN_ix,    NMTOKEN_VRN_ix,  NMTOKENS_VRN_ix,
   NONSGML_VRN_ix,  NOTATION_VRN_ix, NUMBER_VRN_ix,   NUMBERS_VRN_ix,
   NUTOKEN_VRN_ix,  NUTOKENS_VRN_ix, O_VRN_ix,        PCDATA_VRN_ix,
   PI_VRN_ix,       POSTLINK_VRN_ix, PUBLIC_VRN_ix,   RCDATA_VRN_ix,
   RE_VRN_ix,       REQUIRED_VRN_ix, RESTORE_VRN_ix,  RS_VRN_ix,
   SDATA_VRN_ix,    SHORTREF_VRN_ix, SIMPLE_VRN_ix,   SPACE_VRN_ix,
   STARTTAG_VRN_ix, SUBDOC_VRN_ix,   SYNTAX_VRN_ix,   SYSTEM_VRN_ix,
   TEMP_VRN_ix,     TEXT_VRN_ix,     USELINK_VRN_ix,  USEMAP_VRN_ix,
   NOT_FOUND_VRN_ix, VRN_MAX_SIZE = NOT_FOUND_VRN_ix  // must be last entries
};
#endif /* _RSVNAME_EH *********************************************************/
