/*-------------------------------------------------------------------------
                PROJECT YAO OBJECT SGML PARSER (OSGML)
                     Version 1.0 Alpha level 4.0
   An SGML Parser conforming to International Standard ISO 8879 --
                 Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

               INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------
//// samgr.h
///  Declarations for samgr
//   Pierre G. Richard 93/10/15 - Petrus Services and Consulting, Ltd.
  -------------------------------------------------------------------------*/
#ifndef _SAMGR_H
#define _SAMGR_H 1
//******************************************************************************

class SortArray {
public:
   SortArray(
      const unsigned int iItemSize,
      int (*compare)(
         const void *pItem1, const void *pItem2, const void * const pBase
      ),
      unsigned int * const piTotalCount,
      void ** const ppArray,
      const void *pBase
   );
   ~SortArray();
   void enter(void *pItem);
   int sa_compare(int ix1, int ix2);
   void sa_exchange(int ix1, int ix2);
private:
   const void * const pBase;
   void ** const ppArray;
   unsigned int * const piTotalCount;
   int (* compare)(
      const void *pItem1, const void *pItem2, const void * const pBase
   );
   const unsigned int iItemSize;
   int  count;
   int  max;
   void **ppItem;
};
#endif /* _SAMGR_H ************************************************************/
