/*-------------------------------------------------------------------------
                PROJECT YAO OBJECT SGML PARSER (OSGML)
                     Version 1.0 Alpha level 4.0
   An SGML Parser conforming to International Standard ISO 8879 --
                 Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

               INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------
//// skmgr.h
///  Declarations for skmgr
//   Pierre G. Richard 93/10/15 - Petrus Services and Consulting, Ltd.
  -------------------------------------------------------------------------*/
#ifndef _SKMGR_H
#define _SKMGR_H 1
//******************************************************************************

#include "quantity.eh"  // enums

class StringKeeper;

class Parking {
public:
   enum { PARKING_LOT_SIZE = LITLEN_MAX+1 }; // No string > this value!
   unsigned int ofs_start;
   Parking *prev;               // previous parking
   union {
      unsigned int room_left;   // room left until the parking is full
      unsigned int room_taken;  // room taken when the parking is closed
   };
   char lot[PARKING_LOT_SIZE];

   Parking(StringKeeper *pSk);
   void * operator new(size_t size);
   void operator delete(void *pVoid);
};

class StringKeeper
{
   friend Parking;
public:
   StringKeeper();
   ~StringKeeper();
   unsigned int park(
      const char * const pchSource, const unsigned int iLenSource
   );
   char * point(const unsigned int ofsSource) const;
   void output(
      boolean (*out)(ApplicationHandle, void const *, unsigned int),
      ApplicationHandle ahl
   );
private:
   Parking  *pPark;
   unsigned int ofs;
};
#endif /* _SKMGR_H ************************************************************/
