/*-------------------------------------------------------------------------
                PROJECT YAO OBJECT SGML PARSER (OSGML)
                     Version 1.0 Alpha level 4.0
   An SGML Parser conforming to International Standard ISO 8879 --
                 Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

               INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------
//// sort.h
///  Declarations for sort
//   Pierre G. Richard 93/10/15 - Petrus Services and Consulting, Ltd.
  -------------------------------------------------------------------------*/
#ifndef _SORT_H
#define _SORT_H 1
//******************************************************************************

class Sort {
public:
   /*-----------------+
   | Public functions |
   +-----------------*/
   static void quick(
      int iNum,                                   // number of items to sort
      int(*compare_function)(int, int, void *),   // key comparison function
      void(*exchange_function)(int, int, void *), // record exchange function
      void *pvBase                                // passed as it is (base ?)
   );
private:
   /*--------------------+
   | Private definitions |
   +--------------------*/
   struct W {
      int  (*comp)(int, int, void *);
      void (*exchg)(int, int, void *);
      void *base;
   };
   /*------------------+
   | Private functions |
   +------------------*/
   static void hoares_sort(int beg, int end, W const * const);
};
#endif /* _SORT_H *************************************************************/
