/*-------------------------------------------------------------------------
                PROJECT YAO OBJECT SGML PARSER (OSGML)
                     Version 1.0 Alpha level 4.0
   An SGML Parser conforming to International Standard ISO 8879 --
                 Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

               INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------
//// srefdcl.h
///  Declarations for srefdcl
//   Pierre G. Richard 94/02/02 - Petrus Services and Consulting, Ltd.
  -------------------------------------------------------------------------*/
#ifndef _SREFDCL_H
#define _SREFDCL_H 1

/*-----------------------------------------------------------------------------+
| Shortref declaration                                                         |
+-----------------------------------------------------------------------------*/
class ShortrefDcl :
   private virtual PrologDcl           // IS_A?
{
public:
   void parse();
};

/*-----------------------------------------------------------------------------+
| Specific class while compiling                                               |
+-----------------------------------------------------------------------------*/
class ShortrefNode {            // For each shortref map
public:
   ShortrefNode(const int iMaxShortrefs);
   ShortrefNode(
      const ShortrefNode& snodeSource,
      const int iMaxShortrefs,
      const char *pchNamesBufSource,
      const int iNamesBufLength
   );
   ~ShortrefNode();
   boolean set_ent_name(char *pszName, const int iSrNmbr);
   boolean is_defined();
   boolean pile_up(
      StringKeeper& sk, const char *pszName, const int iMaxShortrefs,
      ExpandedHash& expnhashGenEnt,
      ShortrefMap*& pSrmMP, const ShortrefMap* const aSrmTable
   );
   int pile_index();
private:
   union {
      ShortrefMap *pSrm;        // array of sr_max ShortrefMap elements
      int ix;                   // index into the ShortrefMap table
   };
};

/*-- INLINES --*/
inline boolean ShortrefNode::is_defined() { return pSrm? TRUE : FALSE; }
inline int ShortrefNode::pile_index() { return ix; }

#endif /* _SREFDCL_H **********************************************************/
