/*-------------------------------------------------------------------------
                PROJECT YAO OBJECT SGML PARSER (OSGML)
                     Version 1.0 Alpha level 4.0
   An SGML Parser conforming to International Standard ISO 8879 --
                 Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

               INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------
//// syntax.eh
///  Enumerations of syntax
//   Pierre G. Richard 93/10/15 - Petrus Services and Consulting, Ltd.
  -------------------------------------------------------------------------*/
#ifndef _SYNTAX_EH
#define _SYNTAX_EH 1

enum e_FunctionClass {      // FCTCLS: for FUNCTION parameter of the SGML dcl
   NULL_FCTCLS = 0,         //  0 is Reserved
   RE_FCTCLS,
   RS_FCTCLS,
   SPACE_FCTCLS,
   FUNCHAR_FCTCLS,
   MSICHAR_FCTCLS,
   MSOCHAR_FCTCLS,
   MSSCHAR_FCTCLS,
   SEPCHAR_FCTCLS
};

enum e_LiteralType {        // GLC: passed to read_to_end_delimiter
   MINLIT_GLC,
   LIT_GLC,
   PI_GLC
};

enum e_CharRefType {        // Return code from translate_character_ref()
   INVALID_CHRF,
   NAMED_CHRF,
   NUMERIC_CHRF
};

enum { MAX_CHARSET = 256 };         // Maximum CHARSET size

/*----------------------------------------------+
| All the following values define Sgml Classes  |
| on the char code set.  This allows a quick    |
| check of the class of a character by doing a  |
| bit anding with the `gtype' table.            |
+----------------------------------------------*/
//***>Note: This better be defined as a private struct of bit_fields, kinda:
//***>Note: struct Blah { uint S_DIGIT : 1; ... }; Blah gtype[MAX_CHARSET];
//***>Note: I will do it later

#define S_NONSGML          0x0   // UNUSED + unsignificant shunned

/* Name character */
#define S_DIGIT            0x1
#define S_LETTER           0x2
#define S_SPECIAL          0x4
#define S_NMSTRT           0x8
#define S_NMCHAR          0x10

/* Function character */
#define S_SSPCHAR         0x20   // RE, RS, SPACE
#define S_FUNCHAR         0x40   // Inert Function Character
#define S_MSICHAR         0x80
#define S_MSOCHAR        0x100
#define S_MSSCHAR        0x200
#define S_SEPCHAR        0x400

#define S_SGML           0x800   // SGML Character, at least DATACHAR

/*
| These values are used temporarly, only while building the gtype table
*/
#define S_SHUNNABLE       0x80   // (redefines MSICHAR) Can be SHUNNED
#define S_CONTROLS       0x100   // (redefines MSOCHAR) Shunnable Controls
#define S_SHUNNED       0x1000   // Shunned Character
#endif /* _SYNTAX_EH **********************************************************/
