/*
** pubid.h
** resolve publid id for filename ( or something else )
** use STL ( Standard Template Library )
** Pekka Kataja 5.2.1995 
*/

#include <ctype.h>
#include <fstream.h>
#include <map.h>

#ifndef _PUBID_H
#define _PUBID_H

/*
** ResolvePublicId - public id resolver
*/

//struct strLess_ {
//  bool operator() (const char *a, const char *b)
//     const { return strcmp ( a , b ) < 0 ; }
//} ;
//strLess_ strless ;

class ResolvePublicId {
  
  static int classcounter ;
  enum { MAXSTRLEN = 512 } ;

  struct strLess {
    bool operator() (const char *a, const char *b)
      const { return strcmp ( a , b ) < 0 ; }
  } ;
  static map<char *, char *, strLess> idmap ;


public:
  ResolvePublicId () ;
  ResolvePublicId ( const char *catalogfile ) ;
  ~ResolvePublicId () ;
  void addcatalog ( const char *catalogfile ) ;
  static int resolve ( const char *id , char *buffer ) ;
private:
// not implemented, do not use 
  ResolvePublicId ( const ResolvePublicId &rhs ) ;
  ResolvePublicId& operator= ( const ResolvePublicId &rhs ) ;
} ;
 
#endif
