/*-------------------------------------------------------------------------
      PROJECT YAO REFERENCE APPLICATION FOR SGML TESTING (RAST)
                   Version 1.0 Alpha level 2.1
 An SGML application conforming to International Standard ISO 8879 --
               Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

            INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------

          Reference Application for SGML Testing (RAST)
            Conforms to X3.190-199X, draft 3/14/1991

//// arg.h
///  Declarations for arg
//   Pierre G. Richard 1989-07-18 - Petrus Services and Consulting, Ltd.

CHANGE HISTORY
#   Date       Who?          Change & Reason (brief)
  -------------------------------------------------------------------------*/
#ifndef _ARG_H
#define _ARG_H 1

/******************************************************************************/
class Arguments {
public:
   Arguments (
      int argc, const char * const * argv, const char * const pszTerminalName
   );
   boolean is_arg_ok();
   boolean is_debug_mode();
   boolean is_canonical_msg();
   boolean is_ract();
   boolean is_sort_required();
   boolean is_production();
   const char * primary_file_spec();
   const char * cmsg_file_spec();
   const char * ract_file_spec();
   const char * rast_file_spec();
   const char * ocs_file_spec();
private:
   enum { SEPOPT = '-' };         // Option separator on command line
   enum { SEPOPT2 = '/' };        // Alternate option separator on command line
   struct {
      boolean bOk           : 1;  // is everything ok?
      boolean bDebugMode    : 1;  // message on (debug mode)
      boolean bCanonicalMsg : 1;  // produce canonical messages
      boolean bRact         : 1;  // produce ract output
      boolean bSortRequired : 1;  // if FALSE, attributes already sorted
      boolean bProduction   : 1;  // OK to use / produce an ODT
      boolean bUsageSaid    : 1;  // To avoid to repeat the same things
   }is;
   const char * pszPrimaryFileSpec;
   const char * pszCmsgFileSpec;
   const char * pszRactFileSpec;
   const char * pszRastFileSpec;
   const char * pszOcsFileSpec;

   void usage();
};

/*--- INLINES ---*/
inline boolean Arguments::is_arg_ok()        { return is.bOk; }
inline boolean Arguments::is_debug_mode()    { return is.bDebugMode; }
inline boolean Arguments::is_canonical_msg() { return is.bCanonicalMsg; }
inline boolean Arguments::is_ract()          { return is.bRact; }
inline boolean Arguments::is_production()    { return is.bProduction; }
inline boolean Arguments::is_sort_required() { return is.bSortRequired; }
inline const char * Arguments::primary_file_spec() { return pszPrimaryFileSpec;}
inline const char * Arguments::cmsg_file_spec()    { return pszCmsgFileSpec; }
inline const char * Arguments::ract_file_spec()    { return pszRactFileSpec; }
inline const char * Arguments::rast_file_spec()    { return pszRastFileSpec; }
inline const char * Arguments::ocs_file_spec()     { return pszOcsFileSpec; }
#endif /* _ARG_H **************************************************************/
