/*-------------------------------------------------------------------------
      PROJECT YAO REFERENCE APPLICATION FOR SGML TESTING (RAST)
                   Version 1.0 Alpha level 2.1
 An SGML application conforming to International Standard ISO 8879 --
               Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

            INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------

          Reference Application for SGML Testing (RAST)
            Conforms to X3.190-199X, draft 3/14/1991

//// messages.h
///  Declarations for message
//   Pierre G. Richard 1989-07-18 - Petrus Services and Consulting, Ltd.

CHANGE HISTORY
#   Date       Who?          Change & Reason (brief)
  -------------------------------------------------------------------------*/
#ifndef _MESSAGE_H
#define _MESSAGE_H 1

/******************************************************************************/
class RastMessage {
public:
   static void usage();
   static void open_failed(const char *pszFileName);
   static void bad_syntax();
   static void incompatible_versions(
      const char *pszExpected, const char *pszFound
   );
   static void unrecognizable_PI();
};

class RastText {
public:
   static const char * eoxl()               { return "<\n";                 }
   static const char * sodl()               { return "|";                   }
   static const char * somd()               { return "!";                   }
   static const char * stago()              { return "[";                   }
   static const char * rsltelto()           { return "[";                   }
   static const char * etago()              { return "[/";                  }
   static const char * ero()                { return "[&";                  }
   static const char * sinfospec()          { return "[";                   }
   static const char * eodl()               { return "|\n";                 }
   static const char * eomd()               { return "!\n";                 }
   static const char * equal()              { return "=\n";                 }
   static const char * tagc()               { return "]\n";                 }
   static const char * refc()               { return "]\n";                 }
   static const char * rslteltc()           { return "]\n";                 }
   static const char * einfospec()          { return "]\n";                 }
   static const char * pio()                { return "[?\n";                }
   static const char * pic()                { return "]\n";                 }
   static const char * empty_pi()           { return "[?]\n";               }
   static const char * le()                 { return "\n";                  }
   static const char * re()                 { return "#RE\n";               }
   static const char * rs()                 { return "#RS\n";               }
   static const char * tab()                { return "#TAB\n";              }
   static const char * empty()              { return "#EMPTY\n";            }
   static const char * implied()            { return "#IMPLIED\n";          }
   static const char * none()               { return "#NONE\n";             }
   static const char * public_st()          { return "#PUBLIC\n";           }
   static const char * system()             { return "#SYSTEM\n";           }
   static const char * sdata_start()        { return "#SDATA-TEXT\n";       }
   static const char * sdata_end()          { return "#END-SDATA\n";        }
   static const char * subdoc()             { return "#SUBDOC\n";           }
   static const char * cdata_ext()          { return "#CDATA-EXTERNAL\n";   }
   static const char * sdata_ext()          { return "#SDATA-EXTERNAL\n";   }
   static const char * ndata_ext()          { return "#NDATA-EXTERNAL\n";   }
   static const char * unkwn_ext()          { return "#?????-EXTERNAL\n";   }
   static const char * cdata_int()          { return "#CDATA-INTERNAL\n";   }
   static const char * sdata_int()          { return "#SDATA-INTERNAL\n";   }
   static const char * unkwn_int()          { return "#?????-INTERNAL\n";   }
   static const char * entity_end()         { return "#END-ENTITY\n";       }
   static const char * error()              { return "#ERROR\n";            }
   static const char * rast_pi_error()      { return "#RAST-PI-ERROR\n";    }
   static const char * notation()           { return "#NOTATION=";          }
   static const char * active_link()        { return "#ACTIVE-LINK=";       }
   static const char * active_link_end()    { return "#END-ACTIVE-LINK\n";  }
   static const char * simple_link()        { return "#SIMPLE-LINK=";       }
   static const char * simple_link_end()    { return "#END-SIMPLE-LINK\n";  }
   static const char * link_set_info()      { return "#LINK-SET-INFO\n";    }
   static const char * link_rule_info()     { return "#LINK-RULE\n";        }
   static const char * link_result()        { return "#RESULT=";            }
   static const char * concur()             { return "#CONCUR=";            }
   static const char * parser_info()        { return "#PARSER-INFO=";       }
   static const char * parser_info_end()    { return "#END-PARSER-INFO\n";  }
   static const char * active_lpd_pi()      { return "rast-active-lpd:";    }
   static const char * active_dtd_pi()      { return "rast-active-dtd:";    }
   static const char * select_rule_pi()     { return "rast-link-rule:";     }
};
#endif /* _MESSAGE_H **********************************************************/
