/*-------------------------------------------------------------------------
      PROJECT YAO REFERENCE APPLICATION FOR SGML TESTING (RAST)
                   Version 1.0 Alpha level 2.1
 An SGML application conforming to International Standard ISO 8879 --
               Standard Generalized Markup Language
  -------------------------------------------------------------------------
(C) 1987-1994 IBM Corporation

Licensed to Yuan-ze Institute of Technology (YUAN-ZE) for distribution
under the terms of the License and Disclaimer of Warranties for Project
YAO Materials, which includes the following text:

"YUAN-ZE hereby grants to any user: (1) an irrevocable royalty-free,
worldwide, non-exclusive license to use, execute, reproduce, display,
perform and distribute copies of, and to prepare derivative works
based upon these materials; and (2) the right to authorize others to
do any of the foregoing."

The full text of the License and Disclaimer of Warranties for Project YAO
Materials should be consulted before using these materials.
  -------------------------------------------------------------------------

            INTERIM RELEASE RESTRICTED DISTRIBUTION NOTICE

Only a "final" version is subject to the YUAN-ZE license described
above.  A version is final if it is not identified as "Alpha" or
"Beta", or if no later version is released within 60 days.  Interim
releases are confidential and restricted to the original recipient.
  -------------------------------------------------------------------------

          Reference Application for SGML Testing (RAST)
            Conforms to X3.190-199X, draft 3/14/1991

//// rast.h
///  Declarations for rast
//   Pierre G. Richard 1989-07-18 - Petrus Services and Consulting, Ltd.

CHANGE HISTORY
#   Date       Who?          Change & Reason (brief)
  -------------------------------------------------------------------------*/
#ifndef _RAST_H
#define _RAST_H 1

/******************************************************************************/
#include "arg.h"
#include "files.h"
#include "parser.h"
#include "server.h"
#include "errorh.h"

class Rast :                      // a Rast object is made of (in init order)
   private Arguments,             // parsed arguments,
   private RastFiles              // and rast files
{
public:
   Rast(int argc, const char * const * argv, const char * pszTerminalName);
   ~Rast();
   int process();
private:
   Document doc;                  // main document
   SGMLparser *pSgml;             // SGML parser
   e_Event evType;                // current event;

   e_Event next_event();
   void external_id_information();
   void external_entity(const char *pszEntName);
   void internal_sdata_entity();
   void entity_information();
   void external_entity_information();
   void internal_entity_information();
   void composite_att_val();
   void attribute_information();
   void process_element_start();
   void process_element_end();
   void process_record_end();
   void process_data();
   void process_processing_instruction();
   void process_entity_start();
   void ract_result();
};

/*--- INLINE ---*/
inline Rast::~Rast() { delete pSgml; }
inline e_Event Rast::next_event() { evType = pSgml->event(); return evType; }

#endif /* _RAST_H *************************************************************/
